#pragma comment(linker, "/STACK:64000000")
#define _CRT_SECURE_NO_WARNINGS
#include <cstdio>
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <queue>
#include <set>
#include <map>
#include <sstream>
#include <cassert>
#include <cmath>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); i++)
#define forv(i, v) forn(i, v.size())
#define for1(i, n) for (int i = 1; i <= int(n); i++)

#define all(x) x.begin(), x.end()
#define pb push_back
#define mp make_pair

typedef pair<int, int> pii;
typedef vector<int> VI;
typedef long long ll;

#define NMAX 20005
#define INF 1000000009

int n, m;
int x[NMAX], y[NMAX];
int idx[NMAX];
bool used[NMAX];
int ans[NMAX];
int v[NMAX];

int det(int x, int y, int u, int v)
{
	return x * v - y * u;
}
int main()
{

	scanf("%d", &n);
	forn(i, n) scanf("%d %d", &x[i], &y[i]);
	forn(i, n) idx[i] = i;
	int N = n;

	int cnt = 0;
	int next, dst;
	while (n > 0)
	{
		forn(i, n) used[i] = false;
		int ind = -1;
		forn(i, n)
		{
			if (ind == -1 || (x[i] < x[ind] || (x[i] == x[ind] && y[i] < y[ind])))
			{
				ind = i;
			}
		}
		m = 0;
		v[m++] = ind;

		cnt++;

		while (true)
		{
			next = -1;
			dst = INF;
			forn(i, n)
			{
				if (used[i]) continue;
				if (i == v[m - 1]) continue;
				if (next == -1)
				{
					next = i;
					dst = (x[i] - x[v[m - 1]]) * (x[i] - x[v[m - 1]]) + (y[i] - y[v[m - 1]]) * (y[i] - y[v[m - 1]]);
					continue;
				}
				int dt = det(x[i] - x[v[m - 1]], y[i] - y[v[m - 1]], x[next] - x[v[m - 1]], y[next] - y[v[m - 1]]);				
				int dst1 = (x[i] - x[v[m - 1]]) * (x[i] - x[v[m - 1]]) + (y[i] - y[v[m - 1]]) * (y[i] - y[v[m - 1]]);

				if (dt > 0 || (dt == 0 && dst1 < dst))
				{
					next = i;					
					dst = dst1;
				}
			}

			if (next == -1)
			{
				used[v[0]] = true;
				break;
			}
			used[next] = true;
			if (next == v[0]) break;
			v[m++] = next;
		}
		int k = 0;
		forn(i, n)
		{
			if (used[i])
			{
				ans[idx[i]] = cnt;
			}
			else
			{
				x[k] = x[i];
				y[k] = y[i];
				idx[k] = idx[i];
				k++;
			}
		}
		n = k;
	}
	forn(i, N)
	{
		printf("%d\n", ans[i]);
	}
	return 0;
}
