/*
#include<iostream>
#include<math.h>
#include<stdio.h>
using namespace std;

double sqr(double n)
{
	return n*n;
}


struct TPoint
{
	double x,y,z;
	void scan() { scanf("%lf%lf%lf",&x,&y,&z); }
	TPoint(double _x=0,double _y=0,double _z=0) {x=_x;y=_y;z=_z;}
	TPoint operator* (const TPoint &p) { return TPoint(z*p.y-y*p.z,x*p.z-z*p.x,y*p.x-x*p.y); }
	TPoint operator- (const TPoint &p) { return TPoint(x-p.x,y-p.y,z-p.z); }
	TPoint operator/ (double val) { return TPoint(x/val,y/val,z/val); }
	double len() { return sqrt(sqr(x)+sqr(y)+sqr(z)); }
	void print() { printf("[%lf %lf %lf]\n",x,y,z); }
	void norm()
	{
		double l=len();
		x/=l;
		y/=l;
		z/=l;
	}
};




int N,M;
TPoint p[100];

double dist(TPoint pt,TPoint n,double D)
{
	return (n.x*pt.x+n.y*pt.y+n.z*pt.z+D);
}


int LeftRight(TPoint pt,TPoint l,double D)
{



}

double check(TPoint a,TPoint b,TPoint c)
{
	TPoint v=b-a;
	TPoint u=c-a;
	TPoint n = v*u;
	n.norm();
	double D = -(c.x*n.x+c.y*n.y+c.z*n.z);
	double dist = fabs(n.x*pt.x+n.y*pt.y+n.z*pt.z+D);




	int minv=0,maxv=0;
	for(i=0;i<N;i++)
	{
		LeftRight(
	}
}



double getPoly()
{
	TPoint s;
	int i;
	scanf("%d",&N);
	for(i=0;i<N;i++) 
	{
		p[i].scan();
		s+=p[i];
	}
	s=s/double(N);
	for(i=0;i<N;i++)
		for(j=i+1;j<N;j++)
			for(k=j+1;k<N;k++)
			{
				check(p[i],p[j],p[k]);
			}

}



int main()
{
	int i;
	double a= getPoly();
	double b= getPoly();
	



	return 0;
}


*/



#include<iostream>
#include<math.h>
#include<stdio.h>
using namespace std;
const double eps = 0.000000001;
const double equal_eps = 0.00000000001;
double sqr(double n)
{
	return n*n;
}


struct TPoint
{
	double x,y;
	void scan() { scanf("%lf%lf",&x,&y); }
	TPoint(double _x=0,double _y=0,double _z=0) {x=_x;y=_y;}
	bool operator== (const TPoint &p) 
	{
		return fabs(x-p.x)<equal_eps && fabs(y-p.y)<equal_eps;
	}
	double operator* (const TPoint &p) { return x*p.y-y*p.x; }
	TPoint operator- (const TPoint &p) { return TPoint(x-p.x,y-p.y); }
	TPoint operator+ (const TPoint &p) { return TPoint(x+p.x,y+p.y); }
	void operator-= (const TPoint &p) { x-=p.x; y-=p.y; }
	TPoint operator/ (double val) { return TPoint(x/val,y/val); } 
	double len() { return sqrt(sqr(x)+sqr(y)); }
	void print() { printf("[%lf %lf]\n",x,y); }
	void norm()
	{
		double l=len();
		x/=l;	y/=l;
	}
};
struct TTriangle
{
	TPoint a,b,c;
	TTriangle(TPoint _a=TPoint(),TPoint _b=TPoint(),TPoint _c=TPoint()) { a=_a; b=_b; c=_c; }
};

struct TLine
{
	TPoint a,b;
	TLine(TPoint _a=TPoint(),TPoint _b=TPoint()) { a=_a; b=_b; }
};

struct TRect
{
	TPoint a,b;
	TRect(TPoint _a=TPoint(),TPoint _b=TPoint()) { a=_a; b=_b; }
	bool incorrect() {  return (b.x-a.x<0.0)||(b.y-a.y<0.0); }
	bool in(TPoint p) { return (a.x<=p.x&&p.x<=b.x) && (a.y<=p.y&&p.y<=b.y); }
};

TRect box(TLine l)
{
	return TRect(TPoint(min(l.a.x,l.b.x),min(l.a.y,l.b.y)),
				 TPoint(max(l.a.x,l.b.x),max(l.a.y,l.b.y)));
}
int sign(double n)
{
	if(fabs(n)>=equal_eps) return (n<0)?(-1):(1);
	return 0;
}
int cross(TRect r1,TRect r2)
{
	TRect p(TPoint(max(r1.a.x,r2.a.x),max(r1.a.y,r2.a.y)),
			TPoint(min(r1.b.x,r2.b.x),min(r1.b.y,r2.b.y)));
	if(p.incorrect()) return -1;
	TPoint d(p.b.x-p.a.x,p.b.y-p.a.y);
	return sign(max(d.x,d.y));
}







int LeftRight(TLine l,TPoint p)
{
	return sign((p-l.a)*(l.b-l.a));
}



bool onLine(TLine l,TPoint p)
{
	return (LeftRight(l,p)==0);
}
bool inSegment(TLine l,TPoint p)
{
	if(!onLine(l,p)) return false;
	return box(l).in(p);
}

int cross(TLine l1,TLine l2)
{
	TRect bb1 = box(l1), bb2=box(l2);
	int bbCross = cross(bb1,bb2);
	if(bbCross<0) return 0;
	if(onLine(l1,l2.a)&&onLine(l1,l2.b))
		return bbCross?100500:1; 
	int t1 = LeftRight(l1,l2.a);
	int t2 = LeftRight(l1,l2.b);
	if(t1*t2>0) return 0;
	t1 = LeftRight(l2,l1.a);
	t2 = LeftRight(l2,l1.b);
	if(t1*t2>0) return 0;
	return 1;
}

int inVirtex(TTriangle t,TPoint p)
{
	return int(t.a==p)+int(t.b==p)+int(t.c==p);
}

int cross(TTriangle t,TLine l)
{
	int result = -( inVirtex(t,l.a)+inVirtex(t,l.b));
	result += cross(l,TLine(t.a,t.b));
	result += cross(l,TLine(t.b,t.c));
	result += cross(l,TLine(t.a,t.c));
	return result;
}
bool onTriangle(TTriangle t,TPoint p)
{
	return inSegment(t.a,p)||inSegment(t.b,p)||inSegment(t.c,p);
}



double answer;

TLine F;


bool isEnd(double area,int crossCount,bool onBoard)
{
	return (area<eps || crossCount>=2|| onBoard|| crossCount==0); 
}


void solve(TTriangle t,double S)
{
	int crossCount = cross(t,F);
	bool pointOnBoard = onTriangle(t,F.b);

	if(isEnd(S,crossCount,pointOnBoard))
	{
		if(crossCount==2) answer += S;
		return;
	}
	TPoint u = t.c-t.a;
	TPoint v = t.b-t.a;
	TPoint r = t.a+(u+v)/2.0;
	TTriangle a(r,t.a,t.b);
	TTriangle b(r,t.a,t.c);
	solve(a,S/2.0);
	solve(b,S/2.0);
}


int main()
{
	TTriangle t(TPoint(10.0,0.0),TPoint(0.0,0.0),TPoint(10.0,10.0));
	double S = 50.0;
	F.b.scan();
	solve(t,S);
	printf("%.9lf",answer);
	return 0;
}


