#include <iostream>
#include <vector>
#include <bitset>
#include <algorithm>
#include <queue>
#include <cstdio>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>

using namespace std;
typedef int huint;
typedef long long ll;
typedef unsigned long long ull;

#define mp make_pair
#define pb push_back
#define all(x) x.begin(),x.end()

struct v3{
	ll x, y, z;
	v3() {}
	v3(const ll x, const ll y, const ll z): x(x), y(y), z(z) {}
	v3 operator +(const v3& r) const{
		return v3(x + r.x, y + r.y, z + r.z); }
	v3 operator -(const v3& r) const{
		return v3(x - r.x, y - r.y, z - r.z); }
	ll sqlen() const{
		return x * x + y * y + z * z; }
};
ll dot(const v3& a, const v3& b){
	return a.x * b.x + a.y * b.y + a.z * b.z; }
v3 cross(const v3& l, const v3& r){
	return v3(l.y * r.z - l.z * r.y, -l.x * r.z + l.z * r.x, l.x * r.y - l.y * r.x);
}

int main(){
	ios_base::sync_with_stdio(false);
	ll m, h, H;
	cin >> m >> h >> H;
	m -= h;
	v3 A, B, C, D, O;
	cin >> O.x >> O.y;
	O.z = h;
	cin >> A.x >> A.y;
	A.z = 0;
	cin >> B.x >> B.y;
	B.z = 0;
	cin >> C.x >> C.y;
	C.z = 0;
	cin >> D.x >> D.y;
	D.z = H;

	if (m < 0){
		cout << "NO" << endl;
		return  0;
	}

	bool ok = false;
	if (h <= m) ok = true;
	v3 a, b, c;
	//ABD
	a = A - O;
	b = B - O;
	c = D - O;
	ll v = abs(dot(a, cross(b, c)));
	if ((ull)m * (ull)m * (ull)cross(A - B, D - B).sqlen() >= (ull)v * (ull)v) ok = true;
	//ACD
	a = A - O;
	b = C - O;
	c = D - O;
	v = abs(dot(a, cross(b, c)));
	if ((ull)m * (ull)m * (ull)cross(A - C, D - C).sqlen() >= (ull)v * (ull)v) ok = true;
	//BCD
	a = B - O;
	b = C - O;
	c = D - O;
	v = abs(dot(a, cross(b, c)));
	if ((ull)m * (ull)m * (ull)cross(B - C, D - C).sqlen() >= (ull)v * (ull)v) ok = true;
	if (ok) cout << "YES" << endl;
	else cout << "NO" << endl;
	return 0;
}