import java.io.*;
import java.util.*;

public class trap_as {
  Scanner in;
  PrintWriter out;

  public final static int ITER = 100;

  class Point {
    public double x_, y_;
    Point (double x, double y) {
      x_ = x;
      y_ = y;
    }
    Point add(Point other) {
      return new Point(x_ + other.x_, y_ + other.y_);
    }
    Point subtract(Point other) {
      return new Point(x_ - other.x_, y_ - other.y_);
    }
    Point mul(double v) {
      return new Point(x_ * v, y_ * v);
    }
    double cross(Point other) {
      return x_ * other.y_ - y_ * other.x_;
    }
  }

  public void run() throws IOException {
    in = new Scanner(System.in);
    out = new PrintWriter(System.out);
    Point A = new Point(10, 0);
    Point B = new Point(0, 0);
    Point C = new Point(10, 10);
    Point S = new Point(0, 0);
    double x = in.nextDouble();
    double y = in.nextDouble();
    Point F = new Point(x, y);
    Point SF = F.subtract(S);
    double res = 0;
    double s = 25.0;
    for (int iter = 0; iter < ITER; iter++) {
      Point M = B.add(C).mul(0.5);
      Point AS = S.subtract(A);
      Point AM = M.subtract(A);
      Point AF = F.subtract(A);
      Point AB = B.subtract(A);
      double s1 = Math.signum(AM.cross(AS));
      double s2 = Math.signum(AM.cross(AF));
      double sgn = s1 * s2;
      Point SA = A.subtract(S);
      Point SM = M.subtract(S);
      double sgn2 = Math.signum(SF.cross(SA)) * Math.signum(SF.cross(SM));
      if (sgn <= 0 && sgn2 < 0) {
        res += s;
        if (sgn == 0) break;
      }
      if (Math.signum(AM.cross(AB)) * Math.signum(AM.cross(AF)) < 0) {
        B = A;
        A = M;
      } else {
        C = A;
        A = M;
      }
      s /= 2;
    }
    out.println(res);
    out.flush();
  }

  public static void main(String[] args) throws IOException {
    new trap_as().run();
  }
}

