#include <iostream>
#include <cmath>
#include <string>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <fstream>
#include <cassert>
#include <map>
#include <set>
#include <vector>
#include <queue>
#include <stack>
#include <functional>
#include <numeric>
#include <ctime>
#include <cstdlib>
#include <sstream>

using namespace std;

#define f first
#define s second
#define mp make_pair
#define pb push_back
#define pii pair<int, int>
#define pll pair<long long, long long>
#define y1 stupid_y1
#define ll long long
#define vi vector<int>
#define forit(it, s) for(__typeof(s.begin()) it = s.begin(); it != s.end(); it++)
#define all(a) a.begin(), a.end()
#define sqr(x) ((x)*(x))
#define sz(a) (int)a.size()
#define file "a"

const int maxn = (int)1e3+11;
const int inf = int(1e9);
const int mod = inf + 7;
const double eps = 1e-9;
const double pi = acos(-1.0);

struct Point{
	int x, y, z;
	Point (int _x, int _y, int _z){
		x = _x;
		y = _y;
		z = _z;
	}	
	Point (){}
};

struct Plane {
	int A, B, C, D;
	Plane(Point p1, Point p2, Point p3){
		A = p1.y*(p2.z - p3.z) + p2.y*(p3.z - p1.z) + p3.y*(p1.z - p2.z);
		B = p1.z*(p2.x - p3.x) + p2.z*(p3.x - p1.x) + p3.z*(p1.x - p2.x);
		C = p1.x*(p2.y - p3.y) + p2.x*(p3.y - p1.y) + p3.x*(p1.y - p2.y);
		D = -(A*p1.x + B*p1.y + C*p1.z);
	}
	Plane(){}
};

Point p[44];
int m, h, H;

double getDist(Point o, Plane p){
	double A = p.A;
	double B = p.B;
	double C = p.C;
	double D = p.D;
	return abs(A*o.x + B*o.y + C*o.z + D)/sqrt(A*A + B*B + C*C);
}

int main () {

	#ifdef LOCAL
	freopen(file".in", "r", stdin);
	freopen(file".out", "w", stdout);
	#endif

	scanf("%d%d%d", &m, &h, &H);

	int x, y;
	scanf("%d%d", &x, &y);
	p[0] = Point(x, y, h);


	for (int i=1;i<4;i++){
		scanf("%d%d", &x, &y);
		p[i] = Point(x, y, 0);
	}

	scanf("%d%d", &x, &y);
	p[4] = Point(x, y, H);

	int r = m - h;

	double mini = 1e18;

	for (int i=1;i<4;i++){
		for (int j=1;j<4;j++){
			if ( i == j ) continue;
			mini = min(mini, getDist(p[0], Plane(p[i], p[j], p[4])));
		}
	}

	mini = min(mini, getDist(p[0], Plane(p[1], p[2], p[3])));

	if ( mini > r){
		printf("NO\n");
	}
	else
		printf("YES\n");


	#ifdef LOCAL
	cerr << (double)clock() * 1.0 / CLOCKS_PER_SEC << endl;
	#endif

	return 0;
}
