#include <set>
#include <map>
#include <queue>
#include <deque>
#include <vector>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <iostream>
#include <algorithm>
using namespace std;

#define left first
#define right second
#define pb push_back
#define mp make_pair
#define sz(a) ((int)a.size())
#define all(a) a.begin(), a.end()
#define ms(a, x) memset(a, x, sizeof a)
#define sqr(v) ((v) * (v))

typedef long long ll;
typedef vector<int> vi;
typedef pair<int,int> pii;
typedef pair<pii, int> tri;

const int N = 1<<17;
const int inf = 1<<30;

ll m, h, H;

struct pt {
	ll x, y, z;
	void read() {
		cin >> x >> y;
	}
} p, a, b, c, d;

bool ok(pt a, pt b, pt c) {
	ll A = (b.y - a.y) * (c.z - a.z) - (c.y - a.y) * (b.z - a.z);
	ll B = (c.x - a.x) * (b.z - a.z) - (b.x - a.x) * (c.z - a.z);
	ll C = (b.x - a.x) * (c.y - a.y) - (c.x - a.x) * (b.y - a.y);
	ll D = -a.x * A - a.y * B - a.z * C;
	return sqr(A * p.x + B * p.y + C * p.z + D) <= (A*A + B*B + C*C) * sqr(m);
}

int main() {
	#ifdef LOCAL
	freopen("a.in", "r", stdin);
	freopen("a.out", "w", stdout);
	#endif

	cin >> m >> h >> H;

	p.read();

	a.read();
	b.read();
	c.read();
	d.read();

	p.z = h;
	d.z = H;

	m -= h;

	if (m < 0) {
		puts("NO");
		return 0;
	}

	if (h <= m) {
		puts("YES");
		return 0;
	}

	if (ok(a,b,d) || ok(a,c,d) || ok(b,c,d)) {
		puts("YES");
	} else {
		puts("NO");
	}

	return 0;
}
