/*#include<iostream>
#include<math.h>
#include<stdio.h>
#include<map>
using namespace std;

double sqr(double n)
{
	return n*n;
}


struct TPoint
{
	int x,y,index;
	void scan() { scanf("%d%d",&x,&y); }
	TPoint(int _x=0,int _y=0) {x=_x;y=_y;}
	int operator* (const TPoint &p) { return x*p.y-y*p.x; }
	TPoint operator- (const TPoint &p) { return TPoint(x-p.x,y-p.y); }
	double len() { return sqrt(sqr(x)+sqr(y)); }
	void print() { printf("[%lf %lf]\n",x,y); }
	void norm()
	{
		double l=len();
		x/=l;
		y/=l;
	}
};

const int MAX_N = 30000;

int same[MAX_N];
TPoint p[MAX_N];

map<int,map<int,int>> T;


void convexHULL()
{

}


int main()
{
	int N,M=0;
	scanf("%d",&N);

	for(i=0;i<N;i++)
	{
		p[M].scan();
		p[M].index=i+1;
		if(T[p[M].x][p[M].y])
		{
			same[i+1]=T[p[M].x][p[M].y];
		}
		else
		{
			T[p[M].x][p[M].y]=p[M].index;
			M++;
		}
	}
	N=M;
	while(N)
	{
		convexHULL();
	}
	return 0;
}

*/


#include<iostream>
#include<math.h>
#include<stdio.h>
using namespace std;

double sqr(double n)
{
	return n*n;
}


struct TPoint
{
	double x,y,z;
	void scan() { scanf("%lf%lf%lf",&x,&y,&z); }
	TPoint(double _x=0,double _y=0,double _z=0) {x=_x;y=_y;z=_z;}
	TPoint operator* (const TPoint &p) { return TPoint(z*p.y-y*p.z,x*p.z-z*p.x,y*p.x-x*p.y); }
	TPoint operator- (const TPoint &p) { return TPoint(x-p.x,y-p.y,z-p.z); }
	double len() { return sqrt(sqr(x)+sqr(y)+sqr(z)); }
	void print() { printf("[%lf %lf %lf]\n",x,y,z); }
	void norm()
	{
		double l=len();
		x/=l;
		y/=l;
		z/=l;
	}
};
TPoint p[5],pt;
double answer;
void check(TPoint a,TPoint b,TPoint c)
{
	TPoint v=b-a;
	TPoint u=c-a;
	TPoint n = v*u;
	//n.print();
	n.norm();
	//n.print();
	double D = -(c.x*n.x+c.y*n.y+c.z*n.z);
	double dist = fabs(n.x*pt.x+n.y*pt.y+n.z*pt.z+D);
	//printf("%lf\n",dist);
	answer = min(answer,dist);
}

int main()
{
	answer = 2*1000*1000*1000;
	double m,h,H;
	int i;
	scanf("%lf%lf%lf",&m,&h,&H);
	for(i=0;i<5;i++) scanf("%lf%lf",&p[i].x,&p[i].y);
	p[4].z=H;	
	m-=h;
	p[0].z=h;
	TPoint a,b;
	pt=p[0];
	for(i=1;i<=3;i++)
	{
		check(p[i],p[(i+1==4)?1:(i+1)],p[4]);
	}
	check(p[1],p[2],p[3]);
	m-=answer;
	if(m<-1e-9) printf("NO");
	else printf("YES");


	return 0;
}