#include <cstdio>
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <memory.h>
#include <queue>
#include <deque>
#include <stack>
#include <list>
#include <map>
#include <set>
#include <functional>
#include <cstring>
#include <ctime>

using namespace std;

#define all(a) a.begin(), a.end()
#define mp make_pair

typedef long long li;
typedef long double ld;
typedef pair<int, int> pi;
typedef vector<int> vi;

#define FILENAME ""

void solve();
int main() {
#ifdef YA
	string s = FILENAME;
	//assert(!s.empty());
	clock_t start = clock();
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen(FILENAME ".in", "r", stdin);
	//freopen(FILENAME ".out", "w", stdout);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	cout.sync_with_stdio(0);
	cin.tie(0);
	cout.precision(15);
	cout << fixed;

	int t = 1;
	//cin >> t;
	while(t--) {
		solve();
	}
#ifdef YA
	cout << "\n\n" << (clock() - start) / 1.0 / CLOCKS_PER_SEC << "\n\n";
#endif
	return 0;
}


//#define int li


struct Point {
	int x, y;
	int id;

	Point() {
	}

	Point(int x, int y):x(x), y(y), id(-1) {
	}

	Point operator - (const Point& p)const {
		return Point(x - p.x, y - p.y);
	}

	bool operator < (const Point& p) const{
		return x < p.x || x == p.x && y < p.y;
	}

	int operator *(const Point& p) const{
		return x * p.y - y * p.x;
	}
};

void solve() {
	int n;
	cin >> n;
	vector<Point> points(n);
	for(int i = 0; i< n; ++i) {
		cin >> points[i].x >> points[i].y;
		points[i].id = i;
	}

	sort(all(points));

	vector<int> ans(n);

	int ID = 1;

	while(!points.empty()) {
		vector<Point> top, bottom;
		//cout << points.size() << "\n";
		for(int i = 0; i < points.size(); ++i) {
			while(top.size() >= 2 && (points[i] - top.back()) * (top.back() - top[top.size() - 2]) > 0) {
				top.pop_back();
			}
			top.push_back(points[i]);
#define top bottom
			while(top.size() >= 2 && (points[i] - top.back()) * (top.back() - top[top.size() - 2]) < 0) {
				top.pop_back();
			}
			top.push_back(points[i]);
#undef top
		}
		for(int i = 0; i < top.size(); ++i) {
			ans[top[i].id] = ID;
		}
		for(int i = 0; i < bottom.size(); ++i) {
			ans[bottom[i].id] = ID;
		}

		vector<Point> newPoints;
		for(int i = 0; i < points.size(); ++i) {
			if(!ans[points[i].id]) {
				newPoints.push_back(points[i]);
			}
		}
		points = newPoints;
		++ID;
	}

	for(int i = 0; i < n; ++i) {
		cout << ans[i] << "\n";
	}
}