#include <iostream>
#include <algorithm>
#include <cmath>
using namespace std;

struct point
{
	long long x, y, z;
	point () 
	{ z = 0;}
	point(point A, point B)
	{
		x = A.x - B.x;
		y = A.y - B.y;
		z = A.z - B.z;
	}
	point(long long x, long long y, long long z): x(x), y(y), z(z) {}
} a[4], O;

pair<long long, long long> get(point A, point B, point C, point D)
{
	point ab(A, B), ac(A, C), ad(A, D);
	point h = point(ab.y * ac.z - ab.z * ac.y, ab.z * ac.y - ab.x * ac.z, ab.x * ac.y - ab.y * ac.x);
	return make_pair(abs(ab.x * ac.y * ad.z + ab.y * ac.z * ad.x + ab.z * ac.x * ad.y - ab.z * ac.y * ad.x - ab.x * ac.z * ad.y - ab.y * ac.x * ad.z), 
					 h.x*h.x + h.y*h.y + h.z * h.z);
}

int main()
{
	long long m, h;
	cin >> m >> h;
	m -=h;
	cin >> a[3].z;
	cin >> O.x >> O.y;
	O.z = h;
	for(int i = 0; i < 4; i++)
		cin >> a[i].x >> a[i].y;
	if (m < 0) {
		cout << "NO" << endl;
	} else {
		for(int i = 0; i < 4; i++)
		{
			for(int j = i + 1; j < 4; j++)
				for(int k = j + 1; k < 4; k++)
				{
					pair<long long, long long> VS = get(a[i], a[j], a[k], O);
					unsigned long long V = VS.first;
					unsigned long long S2 = VS.second;
					unsigned long long mana = m;
					//cout << m << " " << t << endl;
					//cout << "QE " << m << " " << VS.first << " " << VS.second << endl;
					if (m * m * S2 >= V * V) {
						cout << "YES" << endl;
						return 0;
					}
				}
		}
	}
	cout << "NO" << endl;
}