#include <bits/stdc++.h>

#define pb push_back
#define mp make_pair
#define all(x) (x).begin(), (x).end()
#define x first
#define y second
#define in(n) int (n) = nxt()

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef int itn;
typedef pair<int, int> PII;

int nxt() {
    int res;
    scanf("%d", &res);
    return res;
}


struct pt {
    int x, y;
    int id;
};

int vect(const pt &l, const pt &r) {
    return l.x * r.y - l.y * r.x;
}

int scal(const pt &l, const pt &r) {
    return l.x * r.x + l.y * r.y;
}

void solve(){
    //freopen("output.txt", "w", stdout);
    int n = nxt();
    pt a[n];
    int v = 0;
//    for (int i = 0; i < n / 3; ++i) {
//        a[v].x = i, a[v].y = i, a[v].id = v;
//        ++v;
//        a[v].x = 40000 - 2 * i, a[v].y = i, a[v].id = v;
//        ++v;
//        a[v].x = i, a[v].y = 40000 - 2 * i, a[v].id = v;
//        ++v;
//    }

    for (int i = 0; i < n; ++i) {
        a[i].x = nxt();
        a[i].y = nxt();
        a[i].id = i;
    }
    int sz = n;
    int used[n];
    memset(used, 0, sizeof(used));
    int k = 1;
    while (sz > 1) {
        int leftMost = 0;
        for (int i = 0; i < sz; ++i) {
            if (a[i].x < a[leftMost].x || (a[i].x == a[leftMost].x && a[i].y < a[leftMost].y)) {
                leftMost = i;
            }
        }
        int cur = leftMost;

        while (1) {
            int deltaX = a[cur].x;
            int deltaY = a[cur].y;
            for (int i = 0; i < sz; ++i) {
                a[i].x -= deltaX;
                a[i].y -= deltaY;
            }
            int candidate = -1;
            for (int i = 0; i < sz; ++i) {
                if (used[a[i].id]) continue;
                if (candidate == -1 && i != cur) {
                    candidate = i;
                    continue;
                }
                int v = vect(a[candidate], a[i]);
                if (v > 0) {
                    candidate = i;
                } else {
                    if (v == 0) {
                        int s1 = scal(a[i], a[i]);
                        int s2 = scal(a[candidate], a[candidate]);
                        if (s1 && s1 < s2) {
                            candidate = i;
                        }
                    }
                }
            }
            for (int i = 0; i < sz; ++i) {
                a[i].x += deltaX;
                a[i].y += deltaY;
            }
            cur = candidate;
            used[a[cur].id] = k;

            //cerr << k << " " << a[cur].x << " " << a[cur].y << endl;
            if (cur == leftMost) break;
        }
        int sz2 = 0;
        for (int i = 0; i < sz; ++i) {
            if (!used[a[i].id]) {
                a[sz2++] = a[i];
            }
        }
        sz = sz2;
        ++k;
    }

    if (sz == 1) {
        for (int i = 0; i < sz; ++i) {
            used[a[i].id] = k;
        }
    }
    for (int i = 0; i < n; ++i) {
        printf("%d\n", used[i]);
    }

}

int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL

    solve();

    return 0;
}
