#include <bits/stdc++.h>
using namespace std;

#ifdef SG
	#include "debug/debug.h"
#else
	#define show(...)
	#define debug(...)
	#define deepen(...)
	#define timer(...)
#endif

#define forn(i,n) for (int i = 0; i < int(n); ++i)
#define ford(i,n) for (int i = int(n) - 1; i >= 0; --i)
#define ve vector
#define pa pair
#define tu tuple
#define mp make_pair
#define mt make_tuple
#define pb push_back
#define fs first
#define sc second
#define all(a) (a).begin(), (a).end()
#define sz(a) ((int)(a).size())

typedef double ld;
typedef long long ll;
typedef unsigned long long ull;
typedef unsigned int ui;
typedef unsigned char uc;
typedef pa<int, int> pii;
typedef pa<int, ll> pil;
typedef pa<ll, int> pli;
typedef pa<ll, ll> pll;
typedef ve<int> vi;

const ld pi = 3.1415926535897932384626433832795l;

template<typename T> inline auto sqr (T x) -> decltype(x * x) {return x * x;}
template<typename T> inline T abs (T x) {return x > T() ? x : -x;}
template<typename T1, typename T2> inline bool umx (T1& a, T2 b) {if (a < b) {a = b; return 1;} return 0;}
template<typename T1, typename T2> inline bool umn (T1& a, T2 b) {if (b < a) {a = b; return 1;} return 0;}

typedef pair<ld, ld> pt;
#define x first
#define y second

pt operator + (const pt &a, const pt &b) {
	return pt(a.x + b.x, a.y + b.y);
}

pt operator - (const pt &a, const pt &b) {
	return pt(a.x - b.x, a.y - b.y);
}

pt operator * (const pt &a, ld e) {
	return pt(a.x * e, a.y * e);
}

pt operator / (const pt &a, ld e) {
	return pt(a.x / e, a.y / e);
}

ld operator * (const pt &a, const pt &b) {
	return a.x * b.x + a.y * b.y;
}

ld operator ^ (const pt &a, const pt &b) {
	return a.x * b.y - a.y * b.x;
}

const int N = 100;

struct Input {
	int n;
	int l, r;
	
	pt a[N];
	ld z[N];
	
	bool read () {
		if (!(cin >> n >> l >> r)) {
			return 0;
		}
		forn (i, n) {
			cin >> a[i].x >> a[i].y >> z[i];
		}
		return 1;
	}

	void init (const Input &input) {
		*this = input;
	}
};

struct Data: Input {
	ve<ld> ans;
	
	void write () {
		forn (i, sz(ans)) {
			cout << double(ans[i]) << endl;
		}
	}
	
	virtual void solve () {}
	
	virtual void clear () {
		*this = Data();
	}
};

struct Solution: Data {
	ld calc (ve<pt> &a) {
		forn (i, sz(a)) {
			a[i].x += ld(rand()) / RAND_MAX * 1e-9;
			a[i].y += ld(rand()) / RAND_MAX * 1e-9;
		}
		if (!sz(a)) {
			return 0;
		}
		sort(all(a));
		debug(a);
		sort(a.begin() + 1, a.end(), [&] (const pt &l, const pt &r) {
			return ((l - a[0]) ^ (r - a[0])) > 0;
		});
		debug(a);
		ve<pt> q;
		forn (i, sz(a)) {
			while (sz(q) >= 2 && ((a[i] - q[sz(q) - 1]) ^ (a[i] - q[sz(q) - 2])) > 0) {
				q.pop_back();
			}
			q.pb(a[i]);
		}
		ld res = 0;
		forn (i, sz(q)) {
			res += q[i] ^ q[(i + 1) % sz(q)];
		}
		debug(q);
		forn (i, sz(q)) {
			debug((q[i] - q[(i + sz(q) - 1) % sz(q)]) ^ (q[i] - q[(i + 2 * sz(q) - 2) % sz(q)]));
		}
		return res / 2;
	}
	
	void solve () {
		for (int k = l; k <= r; ++k) {
			ve<pt> q;
			forn (i, n) {
				if (z[i] == k) {
					q.pb(a[i]);
				}
			}
			forn (i, n) {
				forn (j, n) {
					if (z[i] < k && z[j] > k) {
						q.pb((a[i] * (z[j] - k) + a[j] * (k - z[i])) / (z[j] - z[i]));
					}
				}
			}
			ans.pb(calc(q));
		}
	}
	
	void clear () {
		*this = Solution();
	}
};

Solution sol;

int main () {
	cout.setf(ios::showpoint | ios::fixed);
	cout.precision(20);
#ifdef SG
	freopen("a.in", "r", stdin);
//	freopen("output.txt", "w", stdout);
	while (sol.read()) {
		sol.solve();
		sol.write();
		sol.clear();
	}
#else
//	freopen("", "r", stdin);
//	freopen("", "w", stdout);
	sol.read();
	sol.solve();
	sol.write();
#endif
	return 0;
}
