#include <bits/stdc++.h>
using namespace std;

#ifdef SG
	#include "debug/debug.h"
#else
	#define show(...)
	#define debug(...)
	#define deepen(...)
	#define timer(...)
#endif

#define forn(i,n) for (int i = 0; i < int(n); ++i)
#define ford(i,n) for (int i = int(n) - 1; i >= 0; --i)
#define ve vector
#define pa pair
#define tu tuple
#define mp make_pair
#define mt make_tuple
#define pb push_back
#define fs first
#define sc second
#define all(a) (a).begin(), (a).end()
#define sz(a) ((int)(a).size())

typedef long double ld;
typedef long long ll;
typedef unsigned long long ull;
typedef unsigned int ui;
typedef unsigned char uc;
typedef pa<int, int> pii;
typedef pa<int, ll> pil;
typedef pa<ll, int> pli;
typedef pa<ll, ll> pll;
typedef ve<int> vi;

const ld pi = 3.1415926535897932384626433832795l;

template<typename T> inline auto sqr (T x) -> decltype(x * x) {return x * x;}
template<typename T> inline T abs (T x) {return x > T() ? x : -x;}
template<typename T1, typename T2> inline bool umx (T1& a, T2 b) {if (a < b) {a = b; return 1;} return 0;}
template<typename T1, typename T2> inline bool umn (T1& a, T2 b) {if (b < a) {a = b; return 1;} return 0;}

template<typename T> struct pt {
	T x, y, z;
	pt (T x = 0, T y = 0, T z = 0): x(x), y(y), z(z) {}
	template<typename D> pt (const pt<D> &a): x(a.x), y(a.y), z(a.z) {}
};

template<typename T> pt<T> operator + (const pt<T> &a, const pt<T> &b) {
	return pt<T>(a.x + b.x, a.y + b.y, a.z + b.z);
}

template<typename T> pt<T> operator - (const pt<T> &a, const pt<T> &b) {
	return pt<T>(a.x - b.x, a.y - b.y, a.z - b.z);
}

template<typename T> pt<T> operator * (const pt<T> &a, T b) {
	return pt<T>(a.x * b, a.y * b, a.z * b);
}

template<typename T> T operator * (const pt<T> &a, const pt<T> &b) {
	return a.x * b.x + a.y * b.y + a.z * b.z;
}

template<typename T> pt<T> operator ^ (const pt<T> &a, const pt<T> &b) {
	return pt<T>(
		a.y * b.z - a.z * b.y,
		a.z * b.x - a.x * b.z,
		a.x * b.y - a.y * b.x
	);
}

const int N = 60;

struct Input {
	int n[2];
	pt<ll> a[2][N];
	
	bool read () {
		forn (i, 2) {
			if (!(cin >> n[i])) {
				return 0;
			}
			forn (j, n[i]) {
				cin >> a[i][j].x >> a[i][j].y >> a[i][j].z;
			}
		}
		return 1;
	}

	void init (const Input &input) {
		*this = input;
	}
};

struct Data: Input {
	ld ans;
	
	void write () {
		cout << double(ans) << endl;
	}
	
	virtual void solve () {}
	
	virtual void clear () {
		*this = Data();
	}
};

struct Solution: Data {
	ld calc (pt<ld> a, pt<ld> b, pt<ld> c, pt<ld> d) {
		b = b - a;
		c = c - a;
		d = d - a;
		return fabsl((b * (c ^ d)) / sqrtl(sqr((b - c) ^ (b - d))));
	}
	
	bool u[N][N][N];
	int cnt[N][N];
	
	ld calc (int n, pt<ll> *a) {
		memset(u, 0, sizeof u);
		memset(cnt, 0, sizeof cnt);
		ve<vi> q;
		forn (i, n) {
			forn (j, i) {
				forn (k, j) {
					if (u[i][j][k]) {
						continue;
					}
					vi z;
					bool pl = 0, mi = 0;
					forn (t, n) {
						ll s = (a[t] - a[i]) * ((a[t] - a[j]) ^ (a[t] - a[k]));
						if (!s) {
							z.pb(t);
						} else {
							if (s > 0) {
								pl = 1;
							} else {
								mi = 1;
							}
						}
					}
					if (pl && mi) {
						continue;
					}
					q.pb(z);
					forn (i1, sz(z)) {
						forn (j1, sz(z)) {
							forn (k1, sz(z)) {
								u[z[i1]][z[j1]][z[k1]] = 1;
							}
						}
					}
					forn (i1, sz(z)) {
						forn (j1, i1) {
							cnt[z[i1]][z[j1]]++;
							cnt[z[j1]][z[i1]]++;
						}
					}
				}
			}
		}
		forn (i, sz(q)) {
			vi z;
			z.pb(q[i][0]);
			forn (t, sz(q[i]) - 1) {
				forn (j, sz(q[i])) {
					if (sz(z) > 1 && q[i][j] == z[sz(z) - 2]) {
						continue;
					}
					if (cnt[z.back()][q[i][j]] == 2) {
						z.pb(q[i][j]);
						break;
					}
				}
			}
			
			int t = 0;
			while (1) {
				bool have = 0;
				forn (j, sz(z)) {
					if (z[j] == t) {
						have = 1;
					}
				}
				if (!have) {
					break;
				}
				++t;
			}
			
			if ((a[t] - a[z[0]]) * ((a[t] - a[z[1]]) ^ (a[t] - a[z[2]])) < 0) {
				reverse(all(z));
			}
			
			q[i] = z;
		}
		pt<ld> v;
		ld s = 0;
		forn (i, sz(q))	 {
			forn (j, sz(q[i]) - 2) {
				ld f = a[q[i][j]] * (a[q[i][j + 1]] ^ a[q[i].back()]);
				pt<ld> w = a[q[i][j]] + a[q[i][j + 1]] + a[q[i].back()];
				w = w * 0.25l;
				v = v + w * f;
				s += f;
			}
		}
		v = v * (1 / s);
		ld dst = 1e10;
		forn (i, sz(q)) {
			umn(dst, calc(v, a[q[i][0]], a[q[i][1]], a[q[i][2]]));
		}
		return dst;
	}
	
	void solve () {
		ans = calc(n[0], a[0]) + calc(n[1], a[1]);
	}
	
	void clear () {
		*this = Solution();
	}
};

Solution sol;

int main () {
	cout.setf(ios::showpoint | ios::fixed);
	cout.precision(20);
#ifdef SG
	freopen("b.in", "r", stdin);
//	freopen("output.txt", "w", stdout);
	while (sol.read()) {
		sol.solve();
		sol.write();
		sol.clear();
	}
#else
//	freopen("", "r", stdin);
//	freopen("", "w", stdout);
	sol.read();
	sol.solve();
	sol.write();
#endif
	return 0;
}
