#include <bits/stdc++.h>
using namespace std;

#ifdef SG
	#include "debug/debug.h"
#else
	#define show(...)
	#define debug(...)
	#define deepen(...)
	#define timer(...)
#endif

#define forn(i,n) for (int i = 0; i < int(n); ++i)
#define ford(i,n) for (int i = int(n) - 1; i >= 0; --i)
#define ve vector
#define pa pair
#define tu tuple
#define mp make_pair
#define mt make_tuple
#define pb push_back
#define fs first
#define sc second
#define all(a) (a).begin(), (a).end()
#define sz(a) ((int)(a).size())

typedef double ld;
typedef long long ll;
typedef unsigned long long ull;
typedef unsigned int ui;
typedef unsigned char uc;
typedef pa<int, int> pii;
typedef pa<int, ll> pil;
typedef pa<ll, int> pli;
typedef pa<ll, ll> pll;
typedef ve<int> vi;

const ld pi = 3.1415926535897932384626433832795l;

template<typename T> inline auto sqr (T x) -> decltype(x * x) {return x * x;}
template<typename T> inline T abs (T x) {return x > T() ? x : -x;}
template<typename T1, typename T2> inline bool umx (T1& a, T2 b) {if (a < b) {a = b; return 1;} return 0;}
template<typename T1, typename T2> inline bool umn (T1& a, T2 b) {if (b < a) {a = b; return 1;} return 0;}


typedef pair<ld, ld> pt;
#define x first
#define y second

pt operator + (const pt &a, const pt &b) {
	return pt(a.x + b.x, a.y + b.y);
}

pt operator - (const pt &a, const pt &b) {
	return pt(a.x - b.x, a.y - b.y);
}

pt operator * (const pt &a, ld e) {
	return pt(a.x * e, a.y * e);
}

pt operator / (const pt &a, ld e) {
	return pt(a.x / e, a.y / e);
}

ld operator * (const pt &a, const pt &b) {
	return a.x * b.x + a.y * b.y;
}

ld operator ^ (const pt &a, const pt &b) {
	return a.x * b.y - a.y * b.x;
}

const int N = 50000;

struct Input {
	int n;
	pt a[N];
	
	bool read () {
		if (!(cin >> n)) {
			return 0;
		}
		forn (i, n) {
			int x, y;
			scanf("%d%d", &x, &y);
			a[i] = pt(x, y);
		}
		return 1;
	}

	void init (const Input &input) {
		*this = input;
	}
};

struct Data: Input {
	int ans;
	
	void write () {
		cout << ans << endl;
	}
	
	virtual void solve () {}
	
	virtual void clear () {
		*this = Data();
	}
};

struct Solution: Data {
	ve<pa<pt, pt> > lines;
	
	bool check (const pt &a, int i) {
		return ((a - lines[i].fs) ^ (lines[i].sc - lines[i].fs)) < 0;
	}
	
	pt isct (int i, int j) {
		ld s1 = (lines[j].fs - lines[i].fs) ^ (lines[j].sc - lines[i].fs);
		ld s2 = (lines[j].fs - lines[i].sc) ^ (lines[j].sc - lines[i].sc);
		return (lines[i].fs * s2 - lines[i].sc * s1) / (s2 - s1);
	}
	
	pa<bool, pt> fnd1 (int n) {
		ld l = -1e20;
		ld r = 1e20;
		pt res = lines[n].fs;
		forn (i, n) {
			ld s = (lines[n].sc - lines[n].fs) ^ (lines[i].sc - lines[i].fs);
			if (fabsl(s) < 0.5) {
				if (((lines[n].sc - lines[n].fs) ^ (lines[i].fs - lines[n].fs))) {
					continue;
				} else {
					return mp(0, pt());
				}
			}
			pt x = isct(n, i);
			ld v = (x - lines[n].fs) * (lines[n].sc - lines[n].fs);
			if (s > 0) {
				if (umn(r, v)) {
					res = x;
				}
			} else {
				if (umx(l, v)) {
					res = x;
				}
			}
		}
		return mp(l < r, res);
	}
	
	pa<bool, pt> fnd0 () {
		pt q = pt(0, 0);
		forn (j, n) {
			if (!check(q, j)) {
				auto x = fnd1(j);
				if (!x.fs) {
					return mp(0, pt());
				} else {
					q = x.sc;
				}
			}
		}
		return mp(1, q);
	}
	
	pt norm (const pt &a) {
		return a / sqrtl(sqr(a));
	}
	
	bool check (int k) {
		lines.clear();
		forn (i, n) {
			lines.pb(mp(a[i] + norm(a[(i + n - 1) % n] - a[i]) * 1e-9, a[(i + k + 1) % n] + norm(a[(i + k + 2) % n] - a[(i + k + 1) % n]) * 1e-9));
		}
		random_shuffle(all(lines));
		return fnd0().fs;
	}
	
	void solve () {
		reverse(a, a + n);
		int l = 0, r = n - 3;
		while (l != r) {
			int m = (l + r + 1) / 2;
			if (check(m)) {
				l = m;
			} else {
				r = m - 1;
			}
		}
		ans = l + 1;
	}
	
	void clear () {
		*this = Solution();
	}
};

Solution sol;

int main () {
	cout.setf(ios::showpoint | ios::fixed);
	cout.precision(20);
#ifdef SG
	freopen("d.in", "r", stdin);
//	freopen("output.txt", "w", stdout);
	while (sol.read()) {
		sol.solve();
		sol.write();
		sol.clear();
	}
#else
//	freopen("", "r", stdin);
//	freopen("", "w", stdout);
	sol.read();
	sol.solve();
	sol.write();
#endif
	return 0;
}
