#include <bits/stdc++.h>
using namespace std;

#ifdef SG
	#include "debug/debug.h"
#else
	#define show(...)
	#define debug(...)
	#define deepen(...)
	#define timer(...)
#endif

#define forn(i,n) for (int i = 0; i < int(n); ++i)
#define ford(i,n) for (int i = int(n) - 1; i >= 0; --i)
#define ve vector
#define pa pair
#define tu tuple
#define mp make_pair
#define mt make_tuple
#define pb push_back
#define fs first
#define sc second
#define all(a) (a).begin(), (a).end()
#define sz(a) ((int)(a).size())

typedef long double ld;
typedef long long ll;
typedef unsigned long long ull;
typedef unsigned int ui;
typedef unsigned char uc;
typedef pa<int, int> pii;
typedef pa<int, ll> pil;
typedef pa<ll, int> pli;
typedef pa<ll, ll> pll;
typedef ve<int> vi;

const ld pi = 3.1415926535897932384626433832795l;

template<typename T> inline auto sqr (T x) -> decltype(x * x) {return x * x;}
template<typename T> inline T abs (T x) {return x > T() ? x : -x;}
template<typename T1, typename T2> inline bool umx (T1& a, T2 b) {if (a < b) {a = b; return 1;} return 0;}
template<typename T1, typename T2> inline bool umn (T1& a, T2 b) {if (b < a) {a = b; return 1;} return 0;}

typedef pair<ld, ld> pt;
#define x first
#define y second

pt operator + (const pt &a, const pt &b) {
	return pt(a.x + b.x, a.y + b.y);
}

pt operator - (const pt &a, const pt &b) {
	return pt(a.x - b.x, a.y - b.y);
}

pt operator * (const pt &a, ld e) {
	return pt(a.x * e, a.y * e);
}

pt operator / (const pt &a, ld e) {
	return pt(a.x / e, a.y / e);
}

ld operator * (const pt &a, const pt &b) {
	return a.x * b.x + a.y * b.y;
}

ld operator ^ (const pt &a, const pt &b) {
	return a.x * b.y - a.y * b.x;
}

struct Input {
	pt f;
			
	bool read () {
		return cin >> f.x >> f.y;
	}

	void init (const Input &input) {
		*this = input;
	}
};

struct Data: Input {
	ld ans;
	
	void write () {
		cout << double(ans) << "\n";
	}
	
	virtual void solve () {}
	
	virtual void clear () {
		*this = Data();
	}
};

struct Solution: Data {

	bool isct (pt a, pt b, pt c, pt d) {
		a = a + (a - b) * 1e-9;
		b = b + (b - a) * 1e-9;
		c = c + (c - d) * 1e-9;
		d = d - (d - c) * 1e-9;
		if (((c - a) ^ (d - a)) * ((c - b) ^ (d - b)) > 0) {
			return 0;
		}
		if (((a - c) ^ (b - c)) * ((a - d) ^ (b - d)) > 0) {
			return 0;
		}
		return 1;
	}
	
	bool check (pt a_, pt b_, pt c_) {
		pt a[3] = {a_, b_, c_};
		int cnt = 0;
		forn (i, 3) {
			cnt += isct(pt(0, 0), f, a[i], a[(i + 1) % 3]);
		}
		debug();
		debug(a, a + 3);
		debug(cnt);
		return cnt == 2;
	}
	
	pt a[2], b;
	
	void solve () {
		ans = 0;
		b = mp(10, 0);
		a[0] = mp(10, 10);
		a[1] = mp(0, 0);
		while (sqr(a[0] - a[1]) > 0.00001) {
			pt x = (a[0] + a[1]) / 2;
			bool ok = 0;
			forn (i, 2) {
				ld q = ((f - b) ^ (f - x)) / ((a[i] - b) ^ (a[i] - x));
				if (q > 1e-9) {
					if (check(a[1 - i], x, b)) {
						ans += sqr(x - b) / 2;
					}
					a[1 - i] = b;
					b = x;
					ok = 1;
					break;
				}
			}
			if (!ok) {
				if (check(a[0], x, b)) {
					ans += sqr(x - b) / 2;
				}
				if (check(a[1], x, b)) {
					ans += sqr(x - b) / 2;
				}
				return;
			}
		}
	}
	
	void clear () {
		*this = Solution();
	}
};

Solution sol;

int main () {
	cout.setf(ios::showpoint | ios::fixed);
	cout.precision(20);
#ifdef SG
	freopen("g.in", "r", stdin);
//	freopen("output.txt", "w", stdout);
	while (sol.read()) {
		sol.solve();
		sol.write();
		sol.clear();
	}
#else
//	freopen("", "r", stdin);
//	freopen("", "w", stdout);
	sol.read();
	sol.solve();
	sol.write();
#endif
	return 0;
}

