#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>

using namespace std;

#define pb push_back
#define mp make_pair
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#ifdef _WIN32
#define LLD "%I64d"
#else
#define LLD "%lld"
#endif
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define y0 yy0
#define y1 yy1
#define next _next
#define prev _prev
#define rank _rank
#define link _link
#define hash _hash
#define fs first
#define sc second

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int inf = int(1e9);
const double eps = 1e-9;
const double pi = 4 * atan(double(1));

struct vt 
{
	double x, y, z;
	vt(double _x, double _y, double _z)
	{
		x = _x, y = _y, z = _z;
	}
	friend vt operator +(vt a, vt b)
	{
		return vt(a.x + b.x, a.y + b.y, a.z + b.z);
	}
	friend vt operator -(vt a, vt b)
	{
		return vt(a.x - b.x, a.y - b.y, a.z - b.z);
	}
	friend double operator *(vt a, vt b)
	{
		return a.x * b.x + a.y * b.y + a.z * b.z;
	}
	vt(){}
	friend vt operator ^(vt a, vt b)
	{
		return vt(a.y * b.z - b.y * a.z, a.z * b.x - b.z * a.x, a.x * b.y - b.x * a.y);
	}
	double abs()
	{
		return sqrt(x * x + y * y + z * z);
	}
};

int main() {
#ifdef LOCAL42
#define TASK "F"
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#else

#endif
	double m, h, H;
	scanf("%lf %lf %lf", &m, &h, &H);
	double r = m - h;
	if (r < eps)
	{
		puts("NO");
		return 0;
	}
	if (r >= h - eps)
	{
		puts("YES");
		return 0;
	}
	vt q;
	scanf("%lf %lf", &q.x, &q.y);
	q.z = 0;
	vt v[3];
	for (int i = 0; i < 3; i++)
	{
		scanf("%lf %lf", &v[i].x, &v[i].y);
		v[i].z = 0;
	}
	vt u;
	scanf("%lf %lf", &u.x, &u.y);
	u.z = H;
	for (int i = 0; i < 3; i++)
	{
		vt a = v[i];
		vt b = v[(i + 1) % 3];
		double d = fabs(((a - q) ^ (b - q)) * (u - q));
		double e = ((a - q) ^ (b - q)).abs();
		if (e / d + eps >= r)
		{
			puts("YES");
			return 0;
		}
	}
	puts("NO");
	return 0;
}
