#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <limits.h>
#include <queue>
#include <stack>
#include <deque>
#include <set>
#include <map>
#include <hash_set>
#include <hash_map>
#include <utility>
#include <stdio.h>
#include <time.h>
#include <memory.h>
#include <string.h>
using namespace std;

#define EPS 1E-7
#define MOD 10007
#define mp make_pair

long long m,h,H;

struct pt{
	long long x,y,z;
	void read(){
		cin>>x>>y;
		z=0;
	}
};

struct plane{
	long long A,B,C,D;
	plane(pt a, pt b, pt c){
		A = a.y*(b.z-c.z) + b.y*(c.z-a.z) + c.y*(a.z-b.z);
		B = a.z*(b.x-c.x) + b.z*(c.x-a.x) + c.z*(a.x-b.x);
		C = a.x*(b.y-c.y) + b.x*(c.y-a.y) + c.x*(a.y-b.y);
		D = -A*a.x - B*a.y - C*a.z;
	}
};

unsigned long long abs(long long w){
	if(w<0)w=-w;
	return (unsigned long long)w;
}


int main(){
	freopen("input.txt","r",stdin); freopen("output.txt","w",stdout);
	cin>>m>>h>>H;
	pt a,b,c,d,e;
	a.read();
	b.read();
	c.read();
	d.read();
	e.read();

	e.z = H;
	a.z = h;
	m-=h;
	if(m<=0){
		puts("NO");
		return 0;
	}

	unsigned long long M = m;
	plane p1(b,c,d),p2(b,c,e),p3(b,d,e),p4(c,d,e);

	if(M*M*(unsigned long long)((p1.A*p1.A+p1.B*p1.B+p1.C*p1.C)) >= (unsigned long long)abs(p1.A*a.x + p1.B*a.y + p1.C*a.z + p1.D)*(unsigned long long)abs(p1.A*a.x + p1.B*a.y + p1.C*a.z + p1.D)){
		puts("YES");
		return 0;
	}
	if(M*M*(unsigned long long)((p2.A*p2.A+p2.B*p2.B+p2.C*p2.C)) >= (unsigned long long)abs(p2.A*a.x + p2.B*a.y + p2.C*a.z + p2.D)*(unsigned long long)abs(p2.A*a.x + p2.B*a.y + p2.C*a.z + p2.D)){
		puts("YES");
		return 0;
	}
	if(M*M*(unsigned long long)(p3.A*p3.A+p3.B*p3.B+p3.C*p3.C) >= (unsigned long long)abs(p3.A*a.x + p3.B*a.y + p3.C*a.z + p3.D)*(unsigned long long)abs(p3.A*a.x + p3.B*a.y + p3.C*a.z + p3.D)){
		puts("YES");
		return 0;
	}
	if(M*M*(unsigned long long)(p4.A*p4.A+p4.B*p4.B+p4.C*p4.C) >= (unsigned long long)abs(p4.A*a.x + p4.B*a.y + p4.C*a.z + p4.D)*(unsigned long long)abs(p4.A*a.x + p4.B*a.y + p4.C*a.z + p4.D)){
		puts("YES");
		return 0;
	}
	puts("NO");

	return 0;
}
